package com.ekexiu.console.system.dao;

import com.ekexiu.console.system.po.ResearchResult;
import org.jfw.apt.annotation.Nullable;
import org.jfw.apt.orm.annotation.dao.DAO;
import org.jfw.apt.orm.annotation.dao.method.Exclude;
import org.jfw.apt.orm.annotation.dao.method.From;
import org.jfw.apt.orm.annotation.dao.method.OrderBy;
import org.jfw.apt.orm.annotation.dao.method.Where;
import org.jfw.apt.orm.annotation.dao.method.operator.*;
import org.jfw.apt.orm.annotation.dao.param.*;
import org.jfw.apt.orm.core.defaultImpl.StringHandler;
import org.jfw.util.PageQueryResult;

import java.sql.Connection;
import java.sql.SQLException;

/**
 * Created by TT on 2017/10/19.
 */
@DAO
public interface ResearchResultDao {
    @Insert
    int insert(Connection con, ResearchResult researchResult) throws SQLException;

    @Update
    @Exclude("modifyTime")
    int update(Connection con, ResearchResult researchResult) throws SQLException;

    @Nullable
    @SelectOne
    ResearchResult query(Connection con, String id) throws SQLException;

    @PageQuery
    @Where("status='1'")
    @OrderBy("ORDER BY CREATE_TIME DESC")
    PageQueryResult<ResearchResult> pageQuery(Connection con, @GroupSqlColumn(isAnd = false, handlerClass = StringHandler.class, value = {"id IN (SELECT ID FROM RESEARCHER WHERE NAME LIKE ?)"}) @Nullable String key, @Nullable @Like String name, @Nullable @Like String orgName, @Nullable @Like String department, @Nullable @Like String subject, @Nullable @Like String industry ,@Nullable @GtEq @Alias("createTime") String bt, @Nullable @Alias("createTime") @LtEq String et, int pageSize, int pageNo) throws SQLException;

    @UpdateWith
    @From(ResearchResult.class)
    int updateStatus(Connection con, String id, @Set String status) throws SQLException;
}
