package com.ekexiu.console.system.dao;

import com.ekexiu.console.system.po.WebMsgCnt;
import com.ekexiu.console.system.pojo.WebMsgIdxInfo;
import org.jfw.apt.annotation.Nullable;
import org.jfw.apt.orm.annotation.dao.DAO;
import org.jfw.apt.orm.annotation.dao.method.Exclude;
import org.jfw.apt.orm.annotation.dao.method.OrderBy;
import org.jfw.apt.orm.annotation.dao.method.operator.PageQuery;
import org.jfw.apt.orm.annotation.dao.method.operator.SelectList;
import org.jfw.apt.orm.annotation.dao.param.GroupSqlColumn;
import org.jfw.apt.orm.core.defaultImpl.StringHandler;
import org.jfw.util.PageQueryResult;

import java.sql.Connection;
import java.sql.SQLException;
import java.util.List;

/**
 * Created by TT on 2017/9/30.
 */

@DAO
public interface WebMsgDao {

    @Exclude({"showOfOwner", "showOfActor"})
    @PageQuery
    @OrderBy("ORDER BY LAST_TIME DESC,OWNER ASC")
    PageQueryResult<WebMsgIdxInfo> query(Connection con, @Nullable @GroupSqlColumn(handlerClass = StringHandler.class,value = {"own.name like ?","actor.name like ?"},isAnd = false)String name, int pageSize, int pageNo) throws SQLException;

    @SelectList
    @OrderBy("ORDER BY SEND_TIME asc")
    List<WebMsgCnt> queryAll(Connection con, @GroupSqlColumn(handlerClass = StringHandler.class, value = {"SENDER=?", "RECIVER=?"}, isAnd = false) String actor1, @GroupSqlColumn(handlerClass = StringHandler.class, value = {"SENDER=?", "RECIVER=?"}, isAnd = false) String actor2) throws SQLException;
}
